# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
rust-version = "1.86.0"
name = "mdfried"
version = "0.21.0"
authors = ["Benjamin Große <ste3ls@gmail.com>"]
build = false
exclude = [
    "assets/*",
    "!assets/docs",
]
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "A markdown viewer for the terminal that renders images and big headers"
homepage = "https://github.com/benjajaja/mdfried"
readme = "README.md"
license = "GPL-3.0-or-later"
repository = "https://github.com/benjajaja/mdfried"

[package.metadata.release]
sign-commit = true
sign-tag = true

[features]
chafa-dyn = ["ratatui-image/chafa-dyn"]
chafa-static = ["ratatui-image/chafa-static"]
default = [
    "chafa-dyn",
    "svg",
    "mermaid",
]
mermaid = [
    "svg",
    "dep:mermaid-rs-renderer",
]
svg = ["resvg"]

[[bin]]
name = "mdfried"
path = "src/main.rs"
bench = false

[[bench]]
name = "full_parse"
path = "benches/full_parse.rs"
harness = false

[dependencies.ansi-to-tui]
version = "8.0.1"

[dependencies.arborium]
version = "2.17.0"
features = ["all-languages"]

[dependencies.bitflags]
version = "2.10.0"

[dependencies.clap]
version = "4.5.21"
features = [
    "cargo",
    "derive",
]

[dependencies.color-eyre]
version = "0.6.5"

[dependencies.confy]
version = "0.6.1"

[dependencies.cosmic-text]
version = "0.18.2"

[dependencies.crossterm]
version = "0.29"
features = ["use-dev-tty"]

[dependencies.flexi_logger]
version = "0.31.7"
features = ["buffer_writer"]

[dependencies.ghrepo]
version = "0.7.1"

[dependencies.image]
version = "0.25.2"

[dependencies.itertools]
version = "0.14.0"

[dependencies.libc]
version = "0.2"
default-features = false

[dependencies.log]
version = "0.4.28"

[dependencies.mdfrier]
version = "3.0.3"
features = ["ratatui"]

[dependencies.mermaid-rs-renderer]
version = "0.2.2"
optional = true

[dependencies.notify]
version = "8.1.0"

[dependencies.notify-debouncer-mini]
version = "0.6.0"

[dependencies.open]
version = "5.3.3"

[dependencies.ratatui]
version = "^0.30.0"
features = [
    "serde",
    "crossterm_0_29",
]

[dependencies.ratatui-image]
version = "11.0.3"
features = ["serde"]
default-features = false

[dependencies.regex]
version = "1.11.1"

[dependencies.reqwest]
version = "0.11"
features = [
    "rustls-tls",
    "blocking",
]
default-features = false

[dependencies.resvg]
version = "0.47.0"
optional = true

[dependencies.serde]
version = "^1.0"
features = ["derive"]

[dependencies.textwrap]
version = "0.16.2"

[dependencies.tokio]
version = "1.32.0"
features = ["full"]

[dependencies.unicode-width]
version = "0.2.2"

[dependencies.url]
version = "2.5.8"

[dependencies.what-terminal-font]
version = "0.1.1"

[dev-dependencies.criterion]
version = "0.5.1"

[dev-dependencies.ctor]
version = "0.2"

[dev-dependencies.insta]
version = "1.44.3"

[dev-dependencies.pretty_assertions]
version = "1.4"

[lints.clippy]
allow_attributes = "warn"
as_pointer_underscore = "warn"
assertions_on_result_states = "warn"
cfg_not_test = "warn"
dbg_macro = "warn"
default_union_representation = "warn"
deref_by_slicing = "warn"
empty_drop = "warn"
empty_enum_variants_with_brackets = "warn"
empty_structs_with_brackets = "warn"
error_impl_error = "warn"
exit = "warn"
filetype_is_file = "warn"
float_cmp_const = "warn"
format_push_string = "warn"
get_unwrap = "warn"
if_then_some_else_none = "warn"
impl_trait_in_params = "warn"
implicit_clone = "warn"
infinite_loop = "warn"
let_underscore_untyped = "warn"
lossy_float_literal = "warn"
map_err_ignore = "warn"
mem_forget = "warn"
missing_assert_message = "warn"
mod_module_files = "warn"
multiple_inherent_impl = "warn"
mutex_atomic = "warn"
negative_feature_names = "warn"
non_zero_suggestions = "warn"
pathbuf_init_then_push = "warn"
pub_without_shorthand = "warn"
rc_buffer = "warn"
rc_mutex = "warn"
redundant_feature_names = "warn"
redundant_test_prefix = "warn"
redundant_type_annotations = "warn"
ref_patterns = "warn"
rest_pat_in_fully_bound_structs = "warn"
same_name_method = "warn"
semicolon_inside_block = "warn"
str_to_string = "warn"
string_add = "warn"
string_lit_chars_any = "warn"
string_slice = "warn"
suspicious_xor_used_as_pow = "warn"
tests_outside_test_module = "warn"
try_err = "warn"
undocumented_unsafe_blocks = "warn"
unnecessary_safety_comment = "warn"
unnecessary_safety_doc = "warn"
unnecessary_self_imports = "warn"
unneeded_field_pattern = "warn"
unseparated_literal_suffix = "warn"
unused_result_ok = "warn"
unused_trait_names = "warn"
unwrap_used = "warn"
verbose_file_reads = "warn"
wildcard_dependencies = "warn"

[lints.rust]
explicit_outlives_requirements = "warn"
macro_use_extern_crate = "warn"
missing_abi = "warn"
noop_method_call = "warn"
single_use_lifetimes = "warn"
unit_bindings = "warn"
unsafe_op_in_unsafe_fn = "warn"
unused_extern_crates = "warn"
unused_import_braces = "warn"
unused_lifetimes = "warn"
unused_macro_rules = "warn"
unused_qualifications = "warn"

[profile.release]
opt-level = 3
lto = true
codegen-units = 1
